/* vi:set cindent tabstop=2: */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>
#include <time.h>
#include <string.h>

#include "mhihttp.h"

int nodotfiles(struct dirent *dirbuf)
{
		if (dirbuf->d_name[0] == '.')
			return 0;
		return 1;
}

int genindex(int fd, char *directory)
{
		int ndir,i;
		struct dirent **files;
		char url[0x100];
		struct stat statb;
		
		if (chdir(directory) < 0)
				return -1;

		if ((ndir = scandir(".", &files, nodotfiles, alphasort)) < 0) 
				return -1;

    sockputs(fd,"HTTP/1.0 200 OK");
    http_hdr(fd,"text/html");

		sockputs(fd,"<table>");

		while (ndir--) {
				if (stat((*files)->d_name,&statb) < 0) {
						files++;
						continue;
				}
				escapestr(url,(*files)->d_name);
				sockprintf(fd,"<tr><td><a href=\"%s\">%s</a><td>%24s<td>%d\n",
								url,(*files)->d_name,
								ctime(&statb.st_mtime),
								statb.st_size);
				files++;
		}
		
		sockputs(fd,"</table>");

		close(fd);
}
