/* vi:set cindent tabstop=2: */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "mhihttp.h"

/* GZIP: cat xyz | gzip -dc | ...*/
/* BZIP2: cat xyz | bzip2 -d | ... */

int uncompress(int fd)
{
#ifdef GUNZIP
		unsigned char buf[0x10];
		int nread;

		nread = read(fd,buf,0x10);
		lseek(fd,0,SEEK_SET);

		if (nread >=2 )
				if (!memcmp(buf,"\037\213",2)) {
						return mkpipe("/usr/bin/gzip","-dc", fd);
				}

		if (nread >= 3 )
				if (!memcmp(buf,"BZh",3)) {
						return mkpipe("/usr/bin/bzip2","-d", fd);
				}
#endif /* GUNZIP */
		return fd;
}
