/* vi:set cindent tabstop=2: */
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdarg.h>

#include "mhihttp.h"

int
sockgets (int socket, char *buf,int len)
{
  while (--len)
    {
      if (read (socket, buf, 1) != 1)
        return -1;
      if (*buf == '\n')
        break;
      if (*buf != '\r')         /* remove all CRs */
        buf++;
    }
  *buf = 0;
  return 0;
}

int sockputs(int socket, char *buf)
{
	int rc;

	if (( rc = write (socket, buf, strlen (buf))) < 0)
	   return rc;
	return write (socket, "\r\n", 2);
}


int sockprintf (int socket, char * format, ...)
{
		  va_list ap;
			char buf[10240];

		  va_start (ap, format);
		  vsprintf (buf, format, ap);
		  va_end (ap);
		  return write (socket, buf, strlen (buf));
}

